#include <iostream>
#include <sstream>
#include <string>
#include <cmath>
using namespace std;
#include "Console.h"
#include "TEllipszis.h"

TEllipszis::TEllipszis(float x, float y, float a, float b) : TKor(x, y, a) {
    SetNev("Ellipszis");
    this->b = b;
}

float TEllipszis::Lapultsag() const {
    return 1 - min(GetA(), b) / max(GetA(), b);
}

float TEllipszis::Terulet() const {
    return GetA() * b * pi;
}

string TEllipszis::Sztringkent() const {
 	stringstream ss;
    ss << TKor::Sztringkent();
    ss << "b = " << b << endl;
    ss << "Lapultsg: " << Lapultsag() << endl;
	return ss.str();
 }
