#include <iostream>
#include <sstream>
#include <string>
#include <cmath>
using namespace std;

#include "TEllipszis.h"

TEllipszis::TEllipszis(float x, float y, float a, float b) : TKor(x, y, a) {
    SetNev("Ellipszis");
    this->b = b;
}

float TEllipszis::Lapultsag() const {
    return 1 - min(GetA(), b) / max(GetA(), b);
}

float TEllipszis::Terulet() const {
    return GetA() * b * pi;
}

string TEllipszis::ToString() const {
 	stringstream ss;
    ss << TKor::ToString();
    ss << "b = " << b << endl;
    ss << "Lapultsg: " << Lapultsag() << endl;
	return ss.str();
 }
