#include <iostream>
#include <clocale>
using namespace std;
#include "TSikidom.h"
#include "TTeglalap.h"
#include "TEllipszis.h"
#include "Random.h"

int main()
{
    setlocale(LC_ALL,"Hun");
    typedef TSikidom * PSikidom;

	PSikidom *sikidom = new PSikidom[10];
	TTeglalap *teglalap;
	TEllipszis *ellipszis;
	Random velszam;

	for (int i = 0; i < 10; i++) {
		switch (velszam.Next(1, 5)) {
			case 1:
				sikidom[i] = new TKor(0, 0, velszam.Next(1, 10));
				break;
			case 2:
				sikidom[i] = new TEllipszis(0, 0, velszam.Next(1, 10), velszam.Next(1, 10));
				break;
			case 3:
				sikidom[i] = new TNegyzet(0, 0, velszam.Next(1, 10));
				break;
			case 4:
				// vagy default:
				sikidom[i] = new TTeglalap(0, 0, velszam.Next(1, 10), velszam.Next(1, 10));
				break;
		}
	}

	for (int i = 0; i < 10; i++) {
		if (dynamic_cast<TEllipszis *>(sikidom[i])) {
			ellipszis = dynamic_cast<TEllipszis *>(sikidom[i]);
			cout << i << ". ellipszis lapultsga: " << ellipszis->Lapultsag() << endl;
		} else if (dynamic_cast<TTeglalap *>(sikidom[i])) {
			teglalap = dynamic_cast<TTeglalap *>(sikidom[i]);
			cout << i << ". tglalap tlja: " << teglalap->GetAtlo() << endl;
		}
	}

	for (int i = 0; i < 10; i++) {
	    delete sikidom[i];
	}
	delete[] sikidom;
    cin.get();
}
