#include <iostream>
#include <sstream>
#include <cmath>
#include <string>
using namespace std;

#include "TTeglalap.h"

float TTeglalap::GetAtlo() const {
     return sqrt(GetA() * GetA() + b * b);
}

TTeglalap::TTeglalap(float x, float y, float a, float b) : TNegyzet(x, y, a), faktor( 180.0 / 3.14159265 ) {
    SetNev("Tglalap");
    this->b = b;
}

float TTeglalap::Terulet() const {
    return GetA() * b;
}

string TTeglalap::ToString() const {
 	stringstream ss;
    ss << TNegyzet::ToString() << "b = " << b << endl;
	return ss.str();
}

float TTeglalap::Lapultsag() const {
	float asz = 2.0 * atan(GetB() / GetA()) * faktor;
	if (asz > 90) asz = 180 - asz;
	return asz;
}
