#include <iostream>
#include <sstream>
#include <cmath>
#include <string>
using namespace std;

#include "TNegyzet.h"

float TNegyzet::GetAtlo() const {
     return GetA() * gyokketto;
}

float TNegyzet::GetKKSugara() const {
     return GetAtlo() / 2;
}

TNegyzet::TNegyzet() : gyokketto(sqrt(2.0F)){
    SetNev("Ngyzet");
    // implicit mdon meghvja az sosztly paramter nlkli konstruktort!
}

TNegyzet::TNegyzet(float x, float y, float a) : TSikidom(x, y, a), gyokketto(sqrt(2.0F)) {
    SetNev("Ngyzet");
}

float TNegyzet::Terulet() const {
    return GetA() * GetA();
}

string TNegyzet::ToString() const {
 	stringstream ss;
    ss << TSikidom::ToString();
    ss << "tl: " << GetAtlo() << endl;
	return ss.str();
}
