#include <iostream>
#include <typeinfo>
#include <iomanip>
using namespace std;

#include "TJatek.h"
#include "Tablak.h"
#include "TNyul.h"
#include "TKaposzta.h"
#include "TRoka.h"
#include "TUres.h"

void TJatek::Start() {
	TAblak *pablak = new TAblak();
	int  nyulakSzama;
	int rokakSzama;
	// Beolvassuk az adatokat
	// (jelezzk a felhasznlnak a megengedett rtket, de nem ellenrizzk a bert adatot):
	cout << "A tbla mrete (<" << (pablak->maxMeret) << "): ";
	cin >> meret;
	meretPluszEgy = meret + 1;
	cout << "A nyulak szma legfeljebb (<=" << meret*meret << "): ";
	cin >> nyulakSzama;
	cout << "A rkk szma legfeljebb (<=" << meret*meret - nyulakSzama << "): ";
	cin >> rokakSzama; cin.get();
	Console::ClearConsole();
	// Belltjuk az ablak mrett:
	pablak->Meretez(meret);
	// a tovbbiakban nincs szksgnk az ablakobjektumra
	delete pablak;
	// Elksztjk a tblkat:
	TablatKeszit(nyulakSzama, rokakSzama);
	//  Elindtjuk a szimulcit:
	Szimulacio();
	cout << endl << "Vge: Enter";
	cin.get();
}

void TJatek::TablatKeszit(int nyulakSzama, int rokakSzama) {
	int x,y;
	// A tbla szln hagyunk egy-egy res sort, illetve oszlopot
	// (gy knnyebb lesz a szomszdok vizsglata):
	tabla.resize(meretPluszEgy + 1);
	for (int i=0; i<=meretPluszEgy; i++) {
        tabla[i].resize(meretPluszEgy + 1);
	}

    for (int i=0; i<=meretPluszEgy; i++) {
		tabla[i][0] = new TUres(i, 0);
		tabla[i][meretPluszEgy] = new TUres(i, meretPluszEgy);
		tabla[0][i] = new TUres(0, i);
		tabla[meretPluszEgy][i] = new TUres(meretPluszEgy, i);
    }

	// Elszr mindenhov kposztt tesznk:
	for (int i=1; i<=meret; i++)
        for (int j=1; j<=meret; j++) {
			tabla[i][j] = new TKaposzta(i, j);
        }

	// Legfeljebb nyulakSzama darab nyl elhelyezse:
	for (int i=0; i<nyulakSzama; i++) {
		x = velszam.Next(1, meretPluszEgy);
		y = velszam.Next(1, meretPluszEgy);
		if (typeid(*tabla[x][y]) == typeid(TKaposzta)) {
			tabla[x][y] = new TNyul(x, y);
			TKaposzta::db -= 1;
		}
	}
	// Legfeljebb rokakSzama darab rka elhelyezse:
	for (int i=0; i<rokakSzama; i++) {
		x = velszam.Next(1, meretPluszEgy);
		y = velszam.Next(1, meretPluszEgy);
		if (typeid(*tabla[x][y]) == typeid(TKaposzta)) {
			tabla[x][y] = new TRoka(x, y);
			TKaposzta::db -= 1;
		}
	}
}

void TJatek::Szimulacio() {
	int x,y;
	lepes = 0;
	Kiiras();

	while (true)
	{
        lepes ++;
		// Meghatrozzuk a mdosul cellt s az j elemet:
		x = velszam.Next(1, meretPluszEgy);
		y = velszam.Next(1, meretPluszEgy);
		tabla[x][y] = tabla[x][y]->Ujelem();
		tabla[x][y]->Kiir();
		LepesKiir();
        if (Console::KeyPressed(VK_SPACE)) {
            Console::MsgBox("Sznet (OK: tovbb)", cim);
            Console::ClearInputBuffer();
        }
        if(Console::KeyPressed(VK_ESCAPE))
            break; // kilps Esc billentyre
    }
}

void TJatek::Kiiras() {
	Console::SetForegroundColor(Console::WHITE);
	Console::SetCursorPosition(0,0);
	cout << cim;
	LepesKiir();
	cout << "Esc: lell, Szkz: sznet"<<endl;
	// Indul a szimulci.
    Console::MsgBox("Indul a szimulci.", cim);
    Console::ClearInputBuffer();
}

void TJatek::LepesKiir() {
	Console::SetForegroundColor(Console::WHITE);
	Console::SetCursorPosition(0, meretPluszEgy);
	cout << "Lps:     " << setw(7) << lepes << endl;
	cout << "Rka:      " << setw(7) << TRoka::db << endl;
	cout << "Nyl:      " << setw(7) << TNyul::db << endl;
	cout << "Kposzta:  " << setw(7) << TKaposzta::db << endl;
}
