// Egyenletmegolds klnbz stratgikkal

#include <iostream>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <clocale>
using namespace std;
#include "Random.h"

float F(float);
void NyersEro();
void OszdMeg();
void Veletlen();
void Heurisztikus();

Random velszam;

int main()
{
    setlocale(LC_ALL,"Hun");

    cout << "Egyenletmegolds:" << endl << endl;
    NyersEro();
    OszdMeg();
    Veletlen();
    Heurisztikus();

    cin.get();
    return 0;
}

float F(float x) {
    return 2*x*x*x*x - x*x*x - 4*x*x + 2;
}

void NyersEro() {
    int lepesszam = 0;
    float i = 0;
    while (F(i/100) > 0) {
        i++; lepesszam++;
    }
    cout << "Nyers er (~lineris keress)\n";
    cout << "Intervallum: [" << (i-1)/100 << "; " << i/100 << "]\n";
    cout << "x = " << i/100 - 0.005 << endl;
    cout << "Hibakorlt: " << 0.005 << endl;
    cout << "Lpsszm: " << lepesszam << endl;
}

void OszdMeg() {
    float kezd = 0, veg = 1, kozep;
    int lepesszam = 0;
    while (fabs(kezd-veg) >= 0.01) {
        kozep = (kezd+veg)/2;
        if (F(kozep) > 0)
            kezd = kozep;
        else
            veg = kozep;
        lepesszam++;
    }
    cout << "\nOszd meg s uralkodj (~intervallumfelezs)\n";
    cout << "Intervallum: [" << kezd << "; " << veg << "]\n";
    cout << "x = " << (kezd+veg)/2 << endl;
    cout << "Hibakorlt: " << (veg-kezd)/2 << endl;
    cout << "Lpsszm: " << lepesszam << endl;
}

void Veletlen() {
    float kezd = 0, veg = 1, osztopont;
    int lepesszam = 0;
    srand(unsigned(time(NULL)));
    while (veg-kezd >= 0.01) {
        osztopont = kezd + velszam.NextDouble() * (veg-kezd);
        if (F(osztopont) > 0)
            kezd = osztopont;
        else
            veg = osztopont;
        lepesszam++;
    }
    cout << "\nVletlentett (~vletlen osztpont)\n";
    cout << "Intervallum: [" << kezd << "; " << veg << "]\n";
    cout << "x = " << (kezd+veg)/2 << endl;
    cout << "Hibakorlt: " << (veg-kezd)/2 << endl;
    cout << "Lpsszm: " << lepesszam << endl;
}

void Heurisztikus() {
    float kezd = 0, veg = 1, osztopont = 0, elozo;
    int lepesszam = 0;
    do {
        elozo = osztopont;
        osztopont = kezd - F(kezd)*(veg-kezd)/(F(veg)-F(kezd));
        if (F(osztopont) > 0)
            kezd = osztopont;
        else
            veg = osztopont;
        lepesszam++;
    } while (fabs(osztopont-elozo) >= 0.01); // csak becsls a hibra
    cout << "\nHeurisztikus (~hrmdszer)\n";
    cout << "x becslt rtke: " << osztopont << endl;
    cout << "Hibakorlt (becslt rtk): " << fabs(osztopont-elozo) << endl;
    cout << "Lpsszm: " << lepesszam << endl;
}
