#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <clocale>
using namespace std;
#include "Random.h"

struct TDiak {
    int magassag;
    bool fiu;
};

struct TSorozat	{
    vector<TDiak> diak;
    //azrt vezetjk be, hogy szemlletesebb legyen a hivatkozs (a size() helyett)
    int elemszam;
};

const int minsor = 3;           // legalbb ennyi sorozat van
const int maxsor = 5;           // legfeljebb ennyi sorozat van
const int mindiak = 3;          // legalbb ennyi dik van egy sorozatban
const int maxdiak = 15;         // legfeljebb ennyi dik van egy sorozatban
const int minmagassag = 120;    // legalbb ilyen magas egy dik
const int maxmagassag = 180;    // legfeljebb ilyen magas egy dik
const int nincs = -1;           // nem rvnyes bejegyzs

vector<TSorozat> sorozat;
vector<int> megold;
int db;

void Feltolt();
void OsszesMegoldas(bool &);
void Kiir();
void MegoldKiir();
void ElemetKeres(int, bool&, int&);
bool Valaszthato(int, int);
bool NemJo(int, int);
bool Megfelelo(int, int, int);

int main()
{
    bool van = false;

    Feltolt();
    db = 0;
    Kiir();
    cout<< "Megoldasok:" << endl;
    OsszesMegoldas(van);
    if (db == 0)
        cout<< "Nincs megoldas." << endl;

    cin.get();
    return 0;
}

void OsszesMegoldas(bool& van)
{
	int melyik = nincs;

	for (int k=0; k<megold.size(); k++)
	     megold[k] = nincs;

	int i = 0;
	while (i >= 0 && i < sorozat.size()) {
		ElemetKeres(i, van, melyik);
		// az i-edik sorozatban van-e megfelel elem, s ha igen, akkor melyik az
		// rtrnk a kvetkez sorozatra
		if (van)
			megold[i++] = melyik;
		 else   // visszalpnk az elz sorozatra
			megold[i--] = nincs;
        van = (i >= (int)sorozat.size());
        if (van) {
            db ++;
            cout<<setw(3)<<db << ". ";
            MegoldKiir();
            i--;    // Fontos! Visszalps az elz sorozatra.
        }
	}
}

void ElemetKeres(int i, bool& van, int& melyik)
{
	// az i-edik sorozatban tallunk-e megfelel elemet, s ha igen, akkor melyik az
	melyik = megold[i] + 1;
	// kiindulunk a kvetkez elemtl (a visszalpsek miatt), elszr a 0. elemtl
	while (melyik < sorozat[i].elemszam && (!Valaszthato(i, melyik) || NemJo(i, melyik))) {
		melyik++;
	}
	van = (melyik < sorozat[i].elemszam);
}

bool Valaszthato(int i, int melyik)
{
    return sorozat[i].diak[melyik].fiu;
}

bool NemJo(int i, int melyik)
{
    // Az i-edik sorozat Melyik elemt sszehasonltjuk az eddigi vlasztsokkal
    // (itt most elegend lenne csak az elz elemmel sszehasonltani, de ltalnostunk)
    int j = 0;
    while (j < i && Megfelelo(i, melyik, j)) {
        j++;
    }
    return (j < i);
}

bool Megfelelo(int i, int melyik, int j)
{
    return sorozat[j].diak[megold[j]].magassag < sorozat[i].diak[melyik].magassag;
}

void Feltolt()
{
	Random velszam;
	sorozat.resize(velszam.Next(minsor, maxsor + 1));
	for (int i = 0; i < sorozat.size(); i++) {
		sorozat[i].diak.resize(velszam.Next(mindiak, maxdiak + 1));
		sorozat[i].elemszam = sorozat[i].diak.size();
		for (int j = 0; j < sorozat[i].elemszam; j++) {
			sorozat[i].diak[j].magassag = velszam.Next(minmagassag, maxmagassag + 1);
			sorozat[i].diak[j].fiu = (velszam.Next(2) == 0);
		}
	}
	megold.resize(sorozat.size());
}

void Kiir()
{
	cout<< "\n";
	for (int i = 0; i < sorozat.size(); i++) {
		for (int j = 0; j < sorozat[i].diak.size(); j++) {
			cout << ( (sorozat[i].diak[j].fiu) ? "F" : "L");
			cout << (sorozat[i].diak[j].magassag) << " ";
		}
		cout<< endl;
	}
	cout<< endl;
}

void MegoldKiir()
{
	for (int i = 0; i < megold.size(); i++) {
		cout<< "F" << sorozat[i].diak[megold[i]].magassag << " ";
	}
	cout << endl;
}
