﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Kártyalapok osztása
// A képfájlokat először felvettük az erőforrások közé (Project/Properties/Resources/Add resource),
// majd a gy5.Properties.Resources.ResourceManager.GetObject() metódussal rendeltük hozzá a PictureBox Image tulajdonságához.
// (A számjeggyel kezdődő erőforrásnevek elé aláhúzásjel kerül.)
// A megjelenítéshez, módosításhoz célszerű inkább egy ImageList objektumot használni, lásd a C# súgóját.

namespace gy4
{
    public partial class Form1 : Form
    {
        const int n = 52;
        const int szélesség = 71;
        int[] lap = new int[n + 1];
        PictureBox[] kártya = new PictureBox[n + 1];
        int k;

        Random vélszám = new Random();

        public Form1()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            // Töröljük az előzőleg megjelenített lapokat:
            for (int i = 0; i < k; i++)
            {
                this.Controls.Remove(kártya[i]);
            }

            k = Convert.ToInt32(textBox1.Text);
            Oszt();
            Kiír();
            textBox1.Focus();
            textBox1.SelectAll();
        }

        public void Oszt()
        {
            int temp = 0;
            for (int i = 0, j; i < k; i++)
            {
                j = vélszám.Next(i, n);
                // csere:
                temp = lap[i];
                lap[i] = lap[j];
                lap[j] = temp;
            }
        }

        public void Kiír()
        {
            for (int i = 0; i < k; i++)
            {
                kártya[i].Image = gy4.Properties.Resources.ResourceManager.GetObject("_" + lap[i]) as Image;
                kártya[i].Left = (i+1) * (szélesség + 2) - 50;
                this.Controls.Add(kártya[i]);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < n; i++)
            {
                lap[i] = i+1;
            }
            for (int i = 0; i < n; i++)
            {
                kártya[i] = new PictureBox();
                kártya[i].SizeMode = PictureBoxSizeMode.AutoSize;
                kártya[i].Top = 60;
            }
        }
    }
}
