// Dinamikus programozs
// Leghosszabb kzs rszsorozat

#include <iostream>
#include <clocale>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <cstdio>
using namespace std;
#include "Random.h"

void Feltolt();
void Keres();
void Kiir();

int meretS1;                 // a kt sorozat maximlis indexe
int meretS2;
int *s1, *s2;                   // a kt sorozat
vector <vector<char> > honnan;  // honnan rkeztnk az (i,j) cellba
vector <vector<int> > tablazat; // tblzat a megolds meghatrozshoz

int main()
{
    setlocale(LC_ALL,"Hun");
    Feltolt();
    Keres();
    Kiir();
    delete[] s1;
    delete[] s2;
    cin.get();
    return 0;
}

void Keres()
{
	int i, j;
	// A keress algoritmusa:
	for (i = 0; i < meretS1; i++) {
		tablazat[i][0] = 0;
	}
	for (j = 0; j < meretS2; j++) {
		tablazat[0][j] = 0;
	}
	for (i = 1; i < meretS1; i++) {
		for (j = 1; j < meretS2; j++) {
			// egyforma a kt elem
			if (s1[i] == s2[j]) {
				tablazat[i][j] = tablazat[i - 1][j - 1] + 1;
				honnan[i][j] = '\\';
			// a fltte lv rtk nagyobb vagy egyenl, mint a balra lv
			} else if (tablazat[i - 1][j] >= tablazat[i][j - 1]) {
				tablazat[i][j] = tablazat[i - 1][j];
				honnan[i][j] = '^';
			// a balra lv nagyobb, mint a fltte lv
			} else {
				tablazat[i][j] = tablazat[i][j - 1];
				honnan[i][j] = '<';
			}
		}
	}
}

void Feltolt()
{
	// A tmbk feltltse
	Random velszam;
    int i,j;

	meretS1 = velszam.Next(10, 20);
	meretS2 = velszam.Next(10, 20);
	s1 = new int[meretS1];
	s2 = new int[meretS2];
	honnan.resize(meretS1);
	tablazat.resize(meretS1);
	for (i=0; i<meretS1; i++) {
        honnan[i].resize(meretS2);
        tablazat[i].resize(meretS2);
	}
	for (i = 1; i < meretS1; i++) {
		s1[i] = velszam.Next(1, 10);
	}
	for (i = 1; i < meretS2; i++) {
		s2[i] = velszam.Next(1, 10);
	}
    s1[0] = s2[0] = 0;

	// A tanknyvben szerepl plda (tesztelsehez):
//	 delete[] s1;
//	 delete[] s2;
//	 int sx1[] = {0, 1, 2, 3, 2, 4, 1, 2 };
//	 int sx2[] = {0, 2, 4, 3, 1, 2, 1} ;
//	 meretS1 = 8;
//	 meretS2 = 7;
//	 s1 = new int[meretS1];
//	 s2 = new int[meretS2];
//	 memcpy(s1, sx1, sizeof(int)*(meretS1));
//	 memcpy(s2, sx2, sizeof(int)*(meretS1));

	for (i = 0; i < meretS1; i++) {
		for (j = 0; j < meretS2; j++) {
			honnan[i][j] = ' ';
		}
	}
}

void Kiir()
{
	// Az eredmnyek kirsa
	// Ellltjuk a kzs rszsorozat elemeit
	string temp = "";
	char puffer[16];
	int i = meretS1-1;
	int j = meretS2-1;
	while (honnan[i][j] != ' ') {
		switch (honnan[i][j]) {
			case '^':
				i --;
				break;
			case '<':
				j --;
				break;
			case '\\':
                sprintf(puffer, "%d", s1[i]);
				temp = string(puffer) + " " + temp;
				// megjelljk az elemeket (a sorozatok kirshoz kell)
				s1[i] = -s1[i];
				s2[j] = -s2[j];
				i--;
				j--;
				break;
		}
	}

	cout << "\nA sorozatok:" << endl;
	for (i = 1; i < meretS1; i++) {
		if (s1[i] > 0) {
			cout << " " << s1[i] << " ";
		} else {
			cout<< "|" << abs(s1[i]) << "|";
		}
		cout << " ";
	}
	cout<< endl;
	for (i = 1; i < meretS2; i++) {
		if (s2[i] > 0) {
			cout << " " << s2[i] << " ";
		} else {
			cout << "|" << abs(s2[i]) << "|";
		}
		cout << " ";
	}
	cout<< endl;

	cout << "\nA leghosszabb kzs rszsorozat elemszma: " << tablazat[meretS1-1][meretS2-1];
	cout << "\nElemei: ";
	cout << temp << endl;

	cout<< "\nA megoldshoz vezet tblzat:" << endl << "   ";
	for (i = 0; i < meretS2; i++) {
		cout << abs(s2[i]) << "  ";
	}
	cout<< endl;
	for (i = 0; i < meretS1; i++) {
		cout << abs(s1[i]) << ": ";
		for (j = 0; j < meretS2; j++) {
			cout << tablazat[i][j] << "  ";
		}
		cout << endl;
	}
	cout << endl;

	cout << "\nA Honnan tblzat:" << endl << "   ";
	for (i = 0; i < meretS2; i++) {
		cout<< abs(s2[i]) << "  ";
	}
	cout << endl;
	for (i = 0; i < meretS1; i++) {
		cout << abs(s1[i]) << ": ";
		for (j = 0; j < meretS2; j++) {
			cout << honnan[i][j] << "  ";
		}
		cout << endl;
	}
	cout << endl;
}
