// Moh algoritmus
// Teremfoglals
// Vletlen idintervallumok generlsval

#include <iostream>
#include <iomanip>
#include <clocale>
#include <algorithm>
#include <vector>
using namespace std;
#include "random.h"
Random velszam;

void Kivalaszt(int i);
void Kiir();
void Adatok();

// A rendezvnyek kezdetnek s vgnek idpontjt egsz szmokkal reprezentljuk.
// A vwg tmb szerint rendezve kell megadni az idpontokat!

// az esemnyek kezdetnek idpontjai
vector <int> kezd;
// az esemnyek vgnek idpontjai (nvekv sorrendbe rendezve!)
vector <int> veg;
// a kivlasztott esemnyek sorszmai
int megoldas[101];
int n, db;

int main()
{
    setlocale(LC_ALL,"Hun");
    Adatok();
	n = kezd.size()-1;
	cout << "Idintervallumok" << endl;
	for (int i = 1; i <= n; i++) {
        cout << setw(2) << i << ".: " << setw(2) << kezd[i] << " - " << veg[i] << endl;
	}

    int utolso;
	// Iteratv megolds:
	megoldas[1] = 1;
	db = utolso = 1;
	for (int i = 2; i <= n; i++) {
		if (kezd[i] >= veg[utolso]) {
			megoldas[++db] = i;
			utolso = i;
		}
	}
	cout << "\nIteratv megolds:" << endl;
	Kiir();

	// Rekurzv megolds:
	db = 0;
	Kivalaszt(0);
	cout << "\nRekurzv megolds:" << endl;
	Kiir();

    cin.get();
    return 0;
}

void Adatok()
{
	int idopont[2];

	int vege = velszam.Next(10, 24);
	n = velszam.Next(1, 20);
	kezd.resize(n + 1);
	veg.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		do {
			idopont[0] = velszam.Next(1, vege + 1);
			idopont[1] = velszam.Next(1, vege + 1);
			kezd[i] = min(idopont[0], idopont[1]);
			veg[i] = max(idopont[0], idopont[1]);
		} while (!(kezd[i] < veg[i]));
	}

	// egytt rendezi a kt tmbt, a veg elemei szerint nvekv sorrendben
	for (int i=1; i<veg.size()-1; i++)
	  for (int j=i+1; j< veg.size(); j++)
          if (veg[i]>veg[j]) {
            swap(veg[i], veg[j]);
            swap(kezd[i], kezd[j]);
          }
}

void Kivalaszt(int i)
{
	//  rekurzv megolds
	int utolso = i + 1;
	while (utolso <= n && kezd[utolso] < veg[i]) {
		utolso++;
	}
	if (utolso <= n) {
		megoldas[++db] = utolso;
		Kivalaszt(utolso);
	}
}

void Kiir()
{
	int temp = 0;
	for (int i = 1; i <= db; i++) {
		temp = megoldas[i];
		cout << setw(2) << temp << ". program, ideje: ";
		cout << setw(2) << kezd[temp] << " - " << setw(2) << veg[temp] << endl;
	}
	cout << endl;
}
