// 0-1 htizsk-feladat
// Megolds dinamikus programozssal

#include <iostream>
#include <iomanip>
#include <clocale>
#include <vector>
#include <algorithm>
#include <cctype>
using namespace std;
#include "Random.h"

void SorozatKiir();
void EredmenyKiir();
void VelFeltolt();
void FixFeltolt();

int maxSuly;    	    // a sly maximlis rtke (ennyit tud egyszerre elvinni)
vector <int> suly; 	    // a trgyak slya
vector <int> ertek;     // a trgyak rtke
vector <bool> viszi;    // elvisszk-e az adott index slyt
vector <vector <int> > tablazat;    // tblzat a megolds meghatrozshoz
vector <vector <char> > honnan;   	// honnan rkeztnk az [i,j] cellba
int n;    // a trgyak max. indexe
Random velszam;

int main()
{
    setlocale(LC_ALL,"Hun");
    int i, j;
	char valasz;
	cout << "Futtats vletlen vagy tanknyvi adatokkal [v/t]? ";
	cin >> valasz;

	if (toupper(valasz) == 'V')
        VelFeltolt();
    else
        FixFeltolt();

	SorozatKiir();

    cout << "\nMax. sly: ";
    cin >> maxSuly; cin.get();

	tablazat.resize(maxSuly + 1);
	honnan.resize(maxSuly + 1);
	for (i=0; i<maxSuly +1; i++) {
        tablazat[i].resize(n + 1) ;
        honnan[i].resize(n + 1) ;
	}
	viszi.resize(n + 1);

	//A viszi tmb feltltse
	for (j = 0; j <= n; j++) {
		viszi[j] = false;
	}

	// A honnan tmb feltltse
	for (i = 0; i <= maxSuly; i++) {
		for (j = 0; j <= n; j++) {
			honnan[i][j] = '<';
		}
	}

	// A 0 kg-os maximlis slyhoz tartoz (0. index) sor kitltse
	// (nem tudunk elvinni semmit)
	for (j = 0; j <= n; j++) {
		tablazat[0][j] = 0;
	}

	// A suly[0]-hoz tartoz, 0. index oszlop kitltse
	// lehet, hogy a legkisebb slyt sem tudjuk elvinni
	for (i = 0; i <= min(maxSuly, suly[0] - 1); i++) {
		tablazat[i][0] = 0;
		// nem tudjuk elvinni
	}
	for (i = suly[0]; i <= maxSuly; i++) {
		tablazat[i][0] = ertek[0];
		// el tudjuk vinni
		honnan[i][0] = '^';
	}

	// A tblzat tbbi elemnek kitltse (dinamikus progamozs)
	// legfeljebb i font slyt tudunk elvinni
	for (i = 1; i <= maxSuly; i++) {
		// a 0.-tl a j-edik oszlopig vlasztunk trgyat (a 0. oszlopot mr kitltttk)
		for (j = 1; j <= n; j++) {
			if (suly[j] > i) {
				tablazat[i][j] = tablazat[i][j - 1];
			} else if (tablazat[i][j - 1] > ertek[j] + tablazat[i - suly[j]][j - 1]) {
				tablazat[i][j] = tablazat[i][j - 1];
			} else {
				tablazat[i][j] = ertek[j] + tablazat[i - suly[j]][j - 1];
				honnan[i][j] = '^';
			}
		}
	}

	EredmenyKiir();

    cin.get();
    return 0;
}

void SorozatKiir()
{
    int i;
	cout << " ";

	for (i = 1; i <= n + 1; i++) {
		cout << setw(3) << i <<".";
	}
	cout << endl;

	for (i = 0; i <= n; i++) {
		cout << setw(4) << suly[i];
	}
	cout << " font" << endl;

	for (i = 0; i <= n; i++) {
		cout << setw(4) << ertek[i];
	}
	cout << " dnr" << endl;
}

void EredmenyKiir()
{
    int i, j;
	int SulyOssz = 0;
	int ErtekOssz = 0;

	cout << "\nA megoldshoz vezet tblzat" << endl;
	cout << "(adott max. sly esetn hny dnr rtkben tud elvinni trgyakat):" << endl << endl;
	cout << "       Trgyak:" << endl;
	cout << "Max. ";
	for (j = 0; j <= n; j++) {
		cout << setw(4) << suly[j] << "  ";
	}
	cout << " font" << endl << "sly:";
	for (j = 0; j <= n; j++) {
		cout << setw(4) << ertek[j] << "  " ;
	}
	cout << " dnr" << endl;
	for (i = 0; i <= maxSuly; i++) {
		cout << setw(3) << i <<": ";
		for (j = 0; j <= n; j++) {
            cout << setw(4) << tablazat[i][j] << "  ";
		}
		cout << endl;
	}
	cout << endl;

	cout << "A honnan tblzat" << endl;
	cout << "       Trgyak:" << endl;
	cout << "Max. ";
	for (j = 0; j <= n; j++) {
		cout << setw(4) << suly[j] << "  ";
	}
	cout << " font" << endl << "sly:";
	for (j = 0; j <= n; j++) {
		cout << setw(4) << ertek[j] << "  " ;
	}
	cout << " dnr" << endl;
	for (i = 0; i <= maxSuly; i++) {
		cout << setw(3) << i <<": ";
		for (j = 0; j <= n; j++) {
			cout << setw(4) << honnan[i][j] << "  " ;
		}
		cout << endl;
	}
	cout << endl;

	// A viszi tmb feltltse (mely trgyakat vittk el):
	i = maxSuly;
	j = n;
	while (!(i < 0 || j < 0)) {
		switch (honnan[i][j]) {
			case '<':
				j--;
				break;
			default:
				// '^'
				viszi[j] = true;
				i -= suly[j];
				j--;
				break;
		}
	}

	cout<< "Elvitt trgyak:" << endl;
	cout << "Sly:      Ertk:" << endl;
	SulyOssz = 0;
	ErtekOssz = 0;
	for (j = 0; j <= n; j++) {
		if (viszi[j]) {
			cout << setw(4) << suly[j] <<"        " << setw(4) << ertek[j] << endl;
			SulyOssz += suly[j];
			ErtekOssz += ertek[j];
		}
	}
	cout << "----------------------" << endl;
	cout << setw(4) << SulyOssz <<" font   " << setw(4) << ErtekOssz << " dnr" << endl;

	// Ellenrzs:
	cout << endl << endl << "Ellenrzs:" << endl;
	if (SulyOssz <= maxSuly) {
		cout << "sly rendben.";
	} else {
		cout << "sly hibs.";
	}
	cout << endl;
	if (ErtekOssz == tablazat[maxSuly][n]) {
		cout << "rtk rendben.";
	} else {
		cout << "rtk hibs.";
	}
    cout <<endl;
}

void VelFeltolt()
{
	int i, j;
	n = velszam.Next(1, 10);
	suly.resize(n + 1);
	ertek.resize(n + 1);
	for (i = 0; i <= n; i++) {
		suly[i] = velszam.Next(1, 10);
		ertek[i] = velszam.Next(1, 10);
	}

	// rendezi a tmbket a sly szerint
	for (i = 0; i <= n-1; i++)
        for (j = i + 1; j <= n; j++)
            if (suly[i]>suly[j]) {
                swap(suly[i], suly[j]);
                swap(ertek[i], ertek[j]);
            }
}

void FixFeltolt()
{
	int vsuly[]  = { 1, 2, 3 };     // a trgyak slya
	int vertek[] = { 3,	5, 6 }; 	// a trgyak rtke
	suly.assign(vsuly, vsuly+3);
	ertek.assign(vertek, vertek+3);
	n = suly.size()-1;
}
